unit FirstLedByLazu1;

//Very little modified from example at...
//http://wiki.freepascal.org/Lazarus_on_Raspberry_Pi#Native_hardware_access
//... and... (another part, same page)...
//http://wiki.freepascal.org/Lazarus_on_Raspberry_Pi#Switching_a_device_via_the_GPIO_port
//Modifications: CRITCAL: addition of sleep(1000) in FormActivate
//Rems to say what "error" codes SHOULD be seen.

//I also "substituted"(?) a CHECKBOX for the "Togglebox" used in the original.
//(I didn't know what a "togglebox" was. I suspect that's just an old name for
//what for some time at 8/18 has been known as a checkbox.)

//Needs an LED on GPIO17, connected though a resistor to GND. (Test that you have
//that right by moving the wire connected to GPIO17 to the 3v3 coming from
//the Pi. LED should glow, then. Numbering: There are two systems. You want
//"GPIO17" as used on the Sparkfun Pi Wedge (https://www.sparkfun.com/products/13717)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics,
     Dialogs, StdCtrls, Unix, BaseUnix;

type

  { TFirstLedByLazf1 }

  TFirstLedByLazf1 = class(TForm)
    CheckBox1: TCheckBox;
    LogMemo: TMemo;
    procedure CheckBox1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
  private
    { private declarations }
  public
    { public declarations }
  end;

const
  PIN_17: PChar = '17';
  PIN_ON: PChar = '1';
  PIN_OFF: PChar = '0';
  OUT_DIRECTION: PChar = 'out';

var
  FirstLedByLazf1: TFirstLedByLazf1;
  gReturnCode: longint; {stores the result of the IO operation}

implementation

{$R *.lfm}

{ TFirstLedByLazf1 }

procedure TFirstLedByLazf1.FormActivate(Sender: TObject);
//Before you change the state of the CheckBox, you should see 2,0,3,0
//  in the memo. each on its own line, without commas.
var
  fileDesc: integer;
begin
  { Prepare SoC pin 17 (pin 11 on GPIO port) for access: }
  try
    fileDesc := fpopen('/sys/class/gpio/export', O_WrOnly);
    gReturnCode := fpwrite(fileDesc, PIN_17[0], 2); // should give 2
    LogMemo.Lines.Add(IntToStr(gReturnCode));
    sleep(1000);//Suggested in https://forum.lazarus.freepascal.org/index.php?topic=39177.0
  finally
    gReturnCode := fpclose(fileDesc); //should give 0
    LogMemo.Lines.Add(IntToStr(gReturnCode));
  end;
  { Set SoC pin 17 as output: }
  try
    fileDesc := fpopen('/sys/class/gpio/gpio17/direction', O_WrOnly);
    gReturnCode := fpwrite(fileDesc, OUT_DIRECTION[0], 3); //should give 3
    LogMemo.Lines.Add(IntToStr(gReturnCode));
  finally
    gReturnCode := fpclose(fileDesc); //should give 0
    LogMemo.Lines.Add(IntToStr(gReturnCode));
  end;
end;//FormActivate

procedure TFirstLedByLazf1.CheckBox1Change(Sender: TObject);
//each time this SR runs, you should see 1,0, each on own line, no commas,
//appear in memo.
var
  fileDesc: integer;
begin
  if CheckBox1.Checked then
  begin
    { Switth SoC pin 17 on: }
    try
      fileDesc := fpopen('/sys/class/gpio/gpio17/value', O_WrOnly);
      gReturnCode := fpwrite(fileDesc, PIN_ON[0], 1);
      LogMemo.Lines.Add(IntToStr(gReturnCode));
    finally
      gReturnCode := fpclose(fileDesc);
      LogMemo.Lines.Add(IntToStr(gReturnCode));
    end;
  end
  else
  begin
    { Switch SoC pin 17 off: }
    try
      fileDesc := fpopen('/sys/class/gpio/gpio17/value', O_WrOnly);
      gReturnCode := fpwrite(fileDesc, PIN_OFF[0], 1);
      LogMemo.Lines.Add(IntToStr(gReturnCode));
    finally
      gReturnCode := fpclose(fileDesc);
      LogMemo.Lines.Add(IntToStr(gReturnCode));
    end;
  end;
end;//CheckBox1Change handler

procedure TFirstLedByLazf1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var
  fileDesc: integer;
begin
  { Free SoC pin 17: }
  try
    fileDesc := fpopen('/sys/class/gpio/unexport', O_WrOnly);
    gReturnCode := fpwrite(fileDesc, PIN_17[0], 2);
    LogMemo.Lines.Add(IntToStr(gReturnCode));
  finally
    gReturnCode := fpclose(fileDesc);
    LogMemo.Lines.Add(IntToStr(gReturnCode));
  end;
end;//FormClose

end.

